package com.xynet.marketing.controller.inner;

import com.xynet.marketing.service.MemberCouponService;
import com.xynet.marketing.utils.R;
import com.xynet.marketing.utils.collections.map.JHashMap;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * 内部回调通知接口
 *
 * @author hechunping
 * @date 2025/2/26
 */
@RestController
@RequestMapping("inner/notify")
@AllArgsConstructor
@Slf4j
@CrossOrigin(origins = "*")
public class InnerNotifyController {
    private MemberCouponService memberCouponService;

    @PostMapping("paySuccess")
    public R paySuccess(@RequestBody JHashMap<String, Object> param, @RequestHeader Map<String, String> headers) {
        String orderId = param.getString("orderId");
//        String thirdMemberId = param.getString("thirdMemberId");
//        String thirdMercId = param.getString("thirdMercId");
        //TODO 检查订单是否已被处理过
        //核销优惠券
        memberCouponService.verification(param);
        log.info("支付成功回调通知,订单号:{}", orderId);
        return R.ok();
    }

}
