package com.xynet.marketing.controller.member;

import com.xynet.marketing.service.EnquiryService;
import com.xynet.marketing.service.MercService;
import com.xynet.marketing.utils.MemberAuthUtils;
import com.xynet.marketing.utils.R;
import com.xynet.marketing.utils.collections.map.JHashMap;
import com.xynet.marketing.utils.collections.map.JMap;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * 会员询价接口
 *
 * @author hechunping
 * @date 2025/2/25
 */
@RestController
@RequestMapping("member/enquiry")
@AllArgsConstructor
@Slf4j
@CrossOrigin(origins = "*")
public class EnquiryController {

    private EnquiryService enquiryService;

    private MercService mercService;

    @PostMapping("goodsListPrice")
    public R goodsListPrice(@RequestBody JHashMap<String, Object> param, @RequestHeader Map<String, String> headers) {
        String thirdMemberId = MemberAuthUtils.getThirdMemberId(headers);
        param.put("thirdMemberId", thirdMemberId);
        param.put("mercId",
                mercService.thirdMercIdToMercId(
                        headers.get("provider_id"),
                        param.getString("thirdMercId"))
        );
        JMap<String, Object> result = enquiryService.goodsListPrice(param);
        return R.ok(result);
    }

}
