package com.xynet.marketing.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.experimental.Accessors;

import java.time.LocalDateTime;

/**
 * 促销活动表
 * @author hechunping
 * @date 2025/1/21
 */
@Data
@Accessors(chain = true)
@TableName("marketing_promotion")
public class Promotion {
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 商户id
     */
    private Integer mercId;

    /**
     * 活动名称
     */
    private String name;

    private LocalDateTime startTime;

    private LocalDateTime endTime;

    private String type;

    private String price;

    private Boolean isAllDay;

    private String dayTime;

    private Boolean canCoupon = false;

    private String status;

    private Integer userLimitNum;

    private Boolean isAllDevice = true;

    private Boolean isAllGoods = true;

    private LocalDateTime createTime;

    private LocalDateTime updateTime;

    private Integer weight;

    private Boolean enableStatus;
}