package com.xynet.marketing.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateTimeDeserializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateTimeSerializer;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 营销-服务商
 * @author hechunping
 * @date 2025/1/17
 */
@Data
@Accessors(chain = true)
@TableName("marketing_provider")
public class Provider implements Serializable {
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 服务商名称
     */
    private String name;

    /**
     * 调用key
     */
    private String appkey;

    /**
     * 密钥
     */
    private String secret;

    /**
     * 服务商说明
     */
    private String msg;


    /**
     * 创建时间
     */
    @JsonDeserialize(using = LocalDateTimeDeserializer.class)
    @JsonSerialize(using = LocalDateTimeSerializer.class)
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    @JsonDeserialize(using = LocalDateTimeDeserializer.class)
    @JsonSerialize(using = LocalDateTimeSerializer.class)
    @TableField(fill = FieldFill.UPDATE)
    private LocalDateTime updateTime;

    /**
     * 异步通知地址
     */
    private String noticeUrl;

}
